/*:
 * @plugindesc Touches Middle Click
 * @author kin-kun
 * 
 * @help Makes a three fingered tap act like clicking the middle mouse button
 */


/*jshint esversion: 6 */

var Imported = Imported || {}; // jshint ignore:line
if (!Imported.TouchesMiddleClick) {
    Imported.TouchesMiddleClick = "1.0";
    var TouchesMiddleClick = TouchesMiddleClick || {}; // jshint ignore:line

    (function ($) {
        "use strict";

        $._TouchInput__onTouchStart = TouchInput._onTouchStart;
        $._TouchInput__onTouchMove = TouchInput._onTouchMove;
        $._TouchInput__onTouchEnd = TouchInput._onTouchEnd;
        $._TouchInput__onCancel = TouchInput._onCancel;
        $._skipCancel = false;

        $._checkCancel = function (target, event, action) {
            if(event && event.touches) $._skipCancel = (event.touches.length > 2);
            action.call(target, event);
        };

        TouchInput._onCancel = function (x, y) {
            if ($._skipCancel) return;
            $._TouchInput__onCancel.apply(this, arguments);
        };

        TouchInput._onTouchStart = function (event) {
            if (event && event.touches && event.touches.length > 2) {
                for (let i = 0; i < event.changedTouches.length; i++) {
                    const touch = event.changedTouches[i];
                    if (!touch) continue;
                    const x = Graphics.pageToCanvasX(touch.pageX);
                    const y = Graphics.pageToCanvasY(touch.pageY);
                    if (Graphics.isInsideCanvas(x, y)) {
                        this._onMiddleButtonDown.apply(this, arguments);
                        break;
                    }
                }
            }
            $._checkCancel(this, event, $._TouchInput__onTouchStart);
        };

        TouchInput._onTouchMove = function (event) {
            $._checkCancel(this, event, $._TouchInput__onTouchMove);
        };

        TouchInput._onTouchEnd = function (event) {
            $._checkCancel(this, event, $._TouchInput__onTouchEnd);
        };

    })(TouchesMiddleClick);
}